﻿using System;
using System.Collections;
using System.Drawing;

namespace Maze_Try_Hex
{
    class Maze
    {
        private int padd;
        private Random currentCelda;

        struct celda
        {
            //0: no hay pared
            //1: hay pared
            //3: bordes
            public byte LA1, LA2, LA3;
            public byte LD1, LD2, LD3;
        }

        private celda[,] celda0;

        public Maze()
        {
            padd = 10;
            currentCelda = new Random(DateTime.Now.Millisecond);
        }

        public void Generar(Graphics g, int LimiteH, int LimiteV, bool primereVez)
        {
            Stack pila1 = new Stack();
            Stack pila2 = new Stack();

            int totalCeldas, visitedCeldas, thisCelda1, thisCelda2;
            int masdeunaCelda, otraCelda;
            int m = 0, n = 0;

            for (int i = 0; i <= LimiteH/3; i += padd)
                n++; //Horizontal

            for (int i = 0; i <= LimiteV/3; i += padd)
                m++; //vertical

            m += 5; n += 5;
            totalCeldas = n*m;

            if (primereVez)
            {
                celda0 = new celda[m,n];

                for (int i = 0; i < m; i++)
                    for (int j = 0; j < n; j++)
                    {
                        celda0[i,j].LA1 = 1;
                        celda0[i,j].LA2 = 1;
                        celda0[i,j].LA3 = 1;
                        celda0[i,j].LD1 = 1;
                        celda0[i,j].LD2 = 1;
                        celda0[i,j].LD3 = 1;

                        if (j == 0)
                        {
                            celda0[i,j].LA1 = 3;
                            celda0[i,j].LD1 = 3;
                        }

                        if (i == 0)
                            celda0[i,j].LA2 = 3;

                        if (i == 0 && j % 2 == 0)
                        {
                            celda0[i, j].LA1 = 3;
                            celda0[i, j].LA3 = 3;
                        }

                        if (j == n - 1)
                        {
                            celda0[i,j].LA3 = 3;
                            celda0[i,j].LD3 = 3;
                        }

                        if (i == m - 1)                        
                            celda0[i, j].LD2 = 3;

                        if (i == m - 1 && j % 2 != 0)
                        {
                            celda0[i, j].LD1 = 3;
                            celda0[i, j].LD3 = 3;
                        }
                    }

                /*
                 * create a CellStack (LIFO) to hold a list of cell locations  
                set TotalCells = number of cells in grid  
                choose a cell at random and call it CurrentCell  
                set VisitedCells = 1  
   
                while VisitedCells < TotalCells  
                find all neighbors of CurrentCell with all walls intact   
                if one or more found  
                choose one at random  
                knock down the wall between it and CurrentCell  
                push CurrentCell location on the CellStack  
                make the new cell CurrentCell  
                add 1 to VisitedCells off the CellStack   
                else  
                pop the most recent cell entry
                make it CurrentCell 
                endIf 
                endWhile  
                 */
                
                visitedCeldas = 1;
                thisCelda1 = (int)currentCelda.Next(0, m); //Random no incluye el maximo valor
                thisCelda2 = (int)currentCelda.Next(0, n);

                while (visitedCeldas < totalCeldas)
                {
                    masdeunaCelda = 0;
                    int uno = thisCelda2 % 2 == 0 ? 1 : 0;

                    if (celda0[thisCelda1, thisCelda2].LA1 == 1)
                        if (celda0[thisCelda1 - uno, thisCelda2 - 1].LA2 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 - 1].LA3 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 - 1].LD1 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 - 1].LD2 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 - 1].LA1 != 0)
                            masdeunaCelda++;

                    if (celda0[thisCelda1, thisCelda2].LA2 == 1)
                        if (celda0[thisCelda1 - 1, thisCelda2].LA1 != 0 &&
                            celda0[thisCelda1 - 1, thisCelda2].LA3 != 0 &&
                            celda0[thisCelda1 - 1, thisCelda2].LD1 != 0 &&
                            celda0[thisCelda1 - 1, thisCelda2].LA2 != 0 &&
                            celda0[thisCelda1 - 1, thisCelda2].LD3 != 0)
                            masdeunaCelda++;

                    if (celda0[thisCelda1, thisCelda2].LA3 == 1)
                        if (celda0[thisCelda1 - uno, thisCelda2 + 1].LA2 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 + 1].LA1 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 + 1].LA3 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 + 1].LD2 != 0 &&
                            celda0[thisCelda1 - uno, thisCelda2 + 1].LD3 != 0)
                            masdeunaCelda++;

                    uno = thisCelda2 % 2 == 0 ? 0 : 1;

                    if (celda0[thisCelda1, thisCelda2].LD1 == 1)
                        if (celda0[thisCelda1 + uno, thisCelda2 - 1].LA2 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 - 1].LD1 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 - 1].LA1 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 - 1].LD2 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 - 1].LD3 != 0)
                            masdeunaCelda++;

                    if (celda0[thisCelda1, thisCelda2].LD2 == 1)
                        if (celda0[thisCelda1 + 1, thisCelda2].LD2 != 0 &&
                            celda0[thisCelda1 + 1, thisCelda2].LA3 != 0 &&
                            celda0[thisCelda1 + 1, thisCelda2].LA1 != 0 &&
                            celda0[thisCelda1 + 1, thisCelda2].LD1 != 0 &&
                            celda0[thisCelda1 + 1, thisCelda2].LD3 != 0)
                            masdeunaCelda++;

                    if (celda0[thisCelda1, thisCelda2].LD3 == 1)
                        if (celda0[thisCelda1 + uno, thisCelda2 + 1].LD3 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 + 1].LA2 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 + 1].LA3 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 + 1].LD1 != 0 &&
                            celda0[thisCelda1 + uno, thisCelda2 + 1].LD2 != 0)
                            masdeunaCelda++;


                    if (masdeunaCelda > 0) // hay al menos una celda vecina con todas sus paredes
                    {
                        otraCelda = cogerCelda(ref celda0, thisCelda1, thisCelda2, m);
                        pila1.Push(thisCelda1);
                        pila2.Push(thisCelda2);

                        switch (otraCelda)
                        {
                            case 1:
                                thisCelda1--;
                                thisCelda2++;
                                break;

                            case 2:
                                thisCelda2++;
                                break;

                            case 3:
                                thisCelda1--;
                                thisCelda2--;
                                break;

                            case 4:
                                thisCelda2--;
                                break;

                            case 5:
                                thisCelda1--;
                                break;

                            case 6:
                                thisCelda2--;
                                break;

                            case 7:
                                thisCelda1++;
                                thisCelda2--;
                                break;

                            case 8:
                                thisCelda1++;
                                break;

                            case 9:
                                thisCelda2++;
                                break;

                            case 10:
                                thisCelda1++;
                                thisCelda2++;
                                break;
                        }

                        visitedCeldas++;
                    }

                    else
                    {
                        thisCelda1 = (int)pila1.Pop();
                        thisCelda2 = (int)pila2.Pop();
                    }

                } // se terminó el while */
            }  // se terminò el if(primeraVez)

            DibujarLab(g, m, n, LimiteV, LimiteH);
        }

        private int cogerCelda(ref celda[,] celda0, int thisCelda1, int thisCelda2, int m)
        {
            int escoger;
            bool valor = true;
            int c = 0;

            while (valor)
            {
                escoger = currentCelda.Next(1, 7);

                switch (escoger)
                {
                    case 1:
                        if (celda0[thisCelda1,thisCelda2].LA3 == 1)
                        {
                            int uno = thisCelda2 % 2 == 0 ? -1 : 0;
                            if (celda0[thisCelda1 + uno, thisCelda2 + 1].LA1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LA2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LA3 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD3 != 0)
                            {
                                celda0[thisCelda1,thisCelda2].LA3 = 0;
                                celda0[thisCelda1 + uno,thisCelda2 + 1].LD1 = 0;
                                valor = false;
                                c = thisCelda2 % 2 == 0 ? 1 : 2;
                            }
                        }
                        break;

                    case 2:
                        if (celda0[thisCelda1, thisCelda2].LA1 == 1)
                        {
                            int uno = thisCelda2 % 2 == 0 ? -1 : 0;
                            if (celda0[thisCelda1 + uno, thisCelda2 - 1].LA1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LA2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LA3 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD3 != 0)
                            {
                                celda0[thisCelda1, thisCelda2].LA1 = 0;
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD3 = 0;
                                valor = false;
                                c = thisCelda2 % 2 == 0 ? 3 : 4;
                            }
                        }
                        break;

                    case 3:
                        if (celda0[thisCelda1,thisCelda2].LA2 == 1)
                            if (celda0[thisCelda1 - 1, thisCelda2].LA1 != 0 &&
                                celda0[thisCelda1 - 1, thisCelda2].LA2 != 0 &&
                                celda0[thisCelda1 - 1, thisCelda2].LA3 != 0 &&
                                celda0[thisCelda1 - 1, thisCelda2].LD1 != 0 &&
                                celda0[thisCelda1 - 1, thisCelda2].LD2 != 0 &&
                                celda0[thisCelda1 - 1, thisCelda2].LD3 != 0)
                            {
                                celda0[thisCelda1,thisCelda2].LA2 = 0;
                                celda0[thisCelda1 - 1,thisCelda2].LD2 = 0;
                                valor = false;
                                c = 5;
                            }
                        break;

                    case 4:
                        if (celda0[thisCelda1, thisCelda2].LD1 == 1)
                        {
                            int uno = thisCelda2 % 2 == 0 ? 0 : 1;
                            if (celda0[thisCelda1 + uno, thisCelda2 - 1].LA1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LA2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LA3 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LD3 != 0)
                            {
                                celda0[thisCelda1, thisCelda2].LD1 = 0;
                                celda0[thisCelda1 + uno, thisCelda2 - 1].LA3 = 0;
                                valor = false;
                                c = thisCelda2 % 2 == 0 ? 6 : 7;
                            }
                        }
                        break;

                    case 5:
                        if (celda0[thisCelda1, thisCelda2].LD2 == 1)  
                            if (celda0[thisCelda1 + 1, thisCelda2].LA1 != 0 &&
                                celda0[thisCelda1 + 1, thisCelda2].LA2 != 0 &&
                                celda0[thisCelda1 + 1, thisCelda2].LA3 != 0 &&
                                celda0[thisCelda1 + 1, thisCelda2].LD1 != 0 &&
                                celda0[thisCelda1 + 1, thisCelda2].LD2 != 0 &&
                                celda0[thisCelda1 + 1, thisCelda2].LD3 != 0)
                            {
                                celda0[thisCelda1, thisCelda2].LD2 = 0;
                                celda0[thisCelda1 + 1, thisCelda2].LA2 = 0;
                                valor = false;
                                c = 8;
                            }                        
                        break;

                    case 6:
                        if (celda0[thisCelda1, thisCelda2].LD3 == 1)
                        {
                            int uno = thisCelda2 % 2 == 0 ? 0 : 1;
                            if (celda0[thisCelda1 + uno, thisCelda2 + 1].LA1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LA2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LA3 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD1 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD2 != 0 &&
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LD3 != 0)
                            {
                                celda0[thisCelda1, thisCelda2].LD3 = 0;
                                celda0[thisCelda1 + uno, thisCelda2 + 1].LA1 = 0;
                                valor = false;
                                c = thisCelda2 % 2 == 0 ? 9 : 10;
                            }
                        }
                        break;

                } // fin del switch
            }

            return c;
        }

        private void DibujarLab(Graphics g, int m, int n, int LimiteV, int LimiteH)
        {
            int m2 = 0, n2 = 0;
            
            for (int i = 0; i < LimiteV ; i+=2*padd)
            {
                n2 = 0;
                for (int j = 0; j < LimiteH ; j+=2*padd)
                {
                    if (n2 % 2 == 0)
                    {
                        if (celda0[m2, n2].LA1 == 1 || celda0[m2, n2].LA1 == 3)
                            g.DrawLine(Pens.Black, j, i + padd, j + padd, i);

                        if (celda0[m2, n2].LA2 == 1 || celda0[m2, n2].LA2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i, j + 2 * padd, i);

                        if (celda0[m2, n2].LA3 == 1 || celda0[m2, n2].LA3 == 3)
                            g.DrawLine(Pens.Black, j + 2 * padd, i, j + 3 * padd, i + padd);

                        if (celda0[m2, n2].LD1 == 1 || celda0[m2, n2].LD1 == 3)
                            g.DrawLine(Pens.Black, j, i + padd, j + padd, i + 2 * padd);

                        if (celda0[m2, n2].LD2 == 1 || celda0[m2, n2].LD2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i + 2 * padd, j + 2 * padd, i + 2 * padd);

                        if (celda0[m2, n2].LD3 == 1 || celda0[m2, n2].LD3 == 3)
                            g.DrawLine(Pens.Black, j + 2 * padd, i + 2 * padd, j + 3 * padd, i + padd);

                    }

                    else
                    {
                        if (celda0[m2, n2].LA1 == 1 || celda0[m2, n2].LA1 == 3)
                            g.DrawLine(Pens.Black, j, i + 2 * padd, j + padd, i + padd);

                        if (celda0[m2, n2].LA2 == 1 || celda0[m2, n2].LA2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i + padd, j + 2 * padd, i + padd);

                        if (celda0[m2, n2].LA3 == 1 || celda0[m2, n2].LA3 == 3)
                            g.DrawLine(Pens.Black, j + 2 * padd, i + padd, j + 3 * padd, i + 2 * padd);

                        if (celda0[m2, n2].LD1 == 1 || celda0[m2, n2].LD1 == 3)
                            g.DrawLine(Pens.Black, j, i + 2 * padd, j + padd, i + 3 * padd);

                        if (celda0[m2, n2].LD2 == 1 || celda0[m2, n2].LD2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i + 3 * padd, j + 2 * padd, i + 3 * padd);

                        if (celda0[m2, n2].LD3 == 1 || celda0[m2, n2].LD3 == 3)
                            g.DrawLine(Pens.Black, j + 2 * padd, i + 3 * padd, j + 3 * padd, i + 2 * padd);
                    }

                    n2++;
                    if (n2 == n) break;
                }
                m2++;
                if (m2 == m) break;                
            }

        }

    }
}
